C23456789012345678901234567890123456789012345678901234567890123456789012
      SUBROUTINE RINGER(KMAX,KM,K0,K1,K5,JMAX,JM,NMAX,KBC,REZ,DDREZ)
C
      PARAMETER(NDY=200,NDY1=201,NDX=30,NDXY=6000)
      DIMENSION ALM(NDXY,2),AUM(NDXY,2),BCM(NDXY,3),AM(NDXY,3)
      DIMENSION DXR(NDX),FM(NDXY),HM(NDXY),KXR(NDX),FMR(NDX),YM(NDX)
C COMMON BLOCKS MAY JUST SPEED THINGS UP
      COMMON/BIG3S/ALM,AM,AUM,BCM
      COMMON/BIG1S/FM,HM
      COMMON/BNDRY/FMR,KXR,DXR
C
 10   DO 20 M=K1,NMAX
         IF(FM(M).LE.0.0) FM(M)=0.0
         IF(HM(M).LE.0.0) HM(M)=0.0
 20   CONTINUE
      DO 25 M=1,KMAX
         YM(M)=0.0
 25   CONTINUE
C
C SWEEP DOWN
C
      DDREZ=0.0
      REZ=0.0
      K2=1
      L2=0
      L3=KMAX
      DO 130 L=1,JMAX
         IF(L.EQ.1) THEN
	    K6=KMAX-K1
	    GO TO 70
C!ONLY DO - HALF FOR L=1
         ENDIF
         L1=L2
         L2=L3
         L3=L3+KMAX
C
C FIND THE NEW RIGHT HAND SIDE FOR THIS ITERATION
C CALCULATE THE +VE X GRID FLUXES BY CALCULATING YM(1.....K0)
C
         N=L2+1
         N2=L1+1
         YM(1)=HM(N)+
     1        (BCM(N,1)*FM(N2+2)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2+1))
         IF(YM(1).LE.0.0) YM(1)=0.0
         YM(1)=YM(1)/ALM(N,2)
         IF(YM(1).LE.0.0) YM(1)=0.0
         DO 40 K=2,K0
	    N=L2+K
	    N2=L1+K
	    YM(K)=HM(N)+
     1           (BCM(N,1)*FM(N2-1)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2+1))
	    IF(YM(K).LE.0.0) YM(K)=0.0
	    YM(K)=(YM(K)-ALM(N,1)*YM(K-1))/ALM(N,2)
	    IF(YM(K).LE.0.0) YM(K)=0.0
 40      CONTINUE
C
         IF(L.EQ.JMAX) THEN 
            K2=K5
C!K5=KMAX-K0
            GO TO 90
C!ONLY DO + HALF
         ENDIF
C
C CALCULATE -VE X GRID FLUXES BY CALCULATING YM(K1......KMAX)
C
 70      DO 80 K=K1,KM
	    N=L2+K
	    N2=L3+K
	    YM(K)=HM(N)+
     1           (BCM(N,1)*FM(N2-1)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2+1))
	    IF(YM(K).LE.0.0) YM(K)=0.0
	    YM(K)=(YM(K)-ALM(N,1)*YM(K-1))/ALM(N,2)
	    IF(YM(K).LE.0.0) YM(K)=0.0
 80      CONTINUE
         K=KMAX
         N=L2+K
         N2=L3+K
         YM(K)=HM(N)+
     1        (BCM(N,1)*FM(N2-1)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2-2))
         IF(YM(K).LE.0.0) YM(K)=0.0
         YM(K)=(YM(K)-ALM(N,1)*YM(K-1))/ALM(N,2)
         IF(YM(K).LE.0.0) YM(K)=0.0
         YM(K)=YM(K)-AUM(N,2)*YM(K-2)/ALM(N,2)
         IF(YM(K).LE.0.0) YM(K)=0.0
         FST=YM(K)
         FM(L3)=FST
C
C	CONVERT YM(1....KMAX) INTO FM(1......KMAX) MODULO KMAX
C
 90      DO 100 K=K2,K6
	    N1=L3-K
	    N2=N1+1
	    KL=KMAX-K
	    FST=(YM(KL)-FM(N2)*AUM(N1,2))/AUM(N1,1)
	    IF(FST.GE.0.0) THEN
               FM(N1)=FST
	    ELSE
               FM(N1)=0.0
	    ENDIF
 100     CONTINUE
C
         IF(L.EQ.1) THEN
	    FM(K1)=FM(K0)
	    K6=KM-1
C!RESET K6
         ELSE
	    N1=L3-KM
	    FST=(YM(1)-FM(N1+1)*AUM(N1,2)-FM(N1+2)*ALM(N1,1))/AUM(N1,1)
	    IF(FST.GE.0.0) THEN
               FM(N1)=FST
	    ELSE
               FM(N1)=0.0
	    ENDIF
         ENDIF
 130  CONTINUE
C
C SWEEP UP
C
 140  K2=1
      K6=KM-1
      L2=NMAX-KMAX
      L1=L2-KMAX
      DO 220 L=1,JM
         L3=L2
         L2=L1
         L1=L1-KMAX
         IF(L.EQ.JM) THEN
	    K6=KMAX-K1
	    GO TO 180
C     !ONLY - HALF
         ENDIF
C
C FIND THE NEW RIGHT HAND SIDE FOR THIS ITERATION
C
 160     N=L2+1
         N2=L1+1
         YM(1)=HM(N)+
     1        (BCM(N,1)*FM(N2+2)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2+1))
         IF(YM(1).LE.0.0) YM(1)=0.0
         YM(1)=YM(1)/ALM(N,2)
         IF(YM(1).LE.0.0) YM(1)=0.0
         DO 170 K=2,K0
	    N=L2+K
	    N2=L1+K
	    YM(K)=HM(N)+
     1           (BCM(N,1)*FM(N2-1)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2+1))
	    IF(YM(K).LE.0.0) YM(K)=0.0
	    YM(K)=(YM(K)-ALM(N,1)*YM(K-1))/ALM(N,2)
	    IF(YM(K).LE.0.0) YM(K)=0.0
 170     CONTINUE
 180     DO 190 K=K1,KM
	    N=L2+K
	    N2=L3+K
	    YM(K)=HM(N)+
     1           (BCM(N,1)*FM(N2-1)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2+1))
	    IF(YM(K).LE.0.0) YM(K)=0.0
	    YM(K)=(YM(K)-ALM(N,1)*YM(K-1))/ALM(N,2)
	    IF(YM(K).LE.0.0) YM(K)=0.0
 190     CONTINUE
         K=KMAX
         N=L2+K
         N2=L3+K
         YM(K)=HM(N)+
     1        (BCM(N,1)*FM(N2-1)+BCM(N,2)*FM(N2)+BCM(N,3)*FM(N2-2))
         IF(YM(K).LE.0.0) YM(K)=0.0
         YM(K)=(YM(K)-ALM(N,1)*YM(K-1))/ALM(N,2)
         IF(YM(K).LE.0.0) YM(K)=0.0
         YM(K)=YM(K)-AUM(N,2)*YM(K-2)/ALM(N,2)
         IF(YM(K).LE.0.0) YM(K)=0.0
         FST=YM(K)
         DDREZ=DDREZ+ABS(FST)
         REZ=REZ+ABS(FST-FM(L3))
         IF(FST.GE.0.0) THEN
	    FM(L3)=FST
         ELSE
	    FM(L3)=0.0
         ENDIF
         DO 200 K=K2,K6
	    N1=L3-K
	    N2=N1+1
	    KL=KMAX-K
	    FST=(YM(KL)-FM(N2)*AUM(N1,2))/AUM(N1,1)
	    DDREZ=DDREZ+ABS(FST)
	    REZ=REZ+ABS(FST-FM(N1))
	    IF(FST.GE.0.0) THEN
               FM(N1)=FST
	    ELSE
               FM(N1)=0.0
	    ENDIF
 200     CONTINUE
C	 
         IF(L.EQ.1) THEN
	    N1=L3-KM
	    FST=(YM(1)-FM(N1+1)*AUM(N1,2)-FM(N1+2)*ALM(N1,1))/AUM(N1,1)
	    DDREZ=DDREZ+ABS(FST)
	    REZ=REZ+ABS(FST-FM(N1))
	    IF(FST.GE.0.0) THEN
               FM(N1)=FST
	    ELSE
               FM(N1)=0.0
	    ENDIF
         ENDIF
 220  CONTINUE
C
C REFLECT THE FLUX EXITING AT THE TOP BACK DOWN TO MIMIC LOOP SYMMETRY
C
      IF(KBC.EQ.1) THEN
         DO 240 K=1,K0
	    L=KXR(K)
	    FM(K)=FMR(K)+FM(L)-DXR(K)*(FM(L)-FM(L-1))
 240     CONTINUE
      ENDIF
      RETURN
      END
C
C23456789012345678901234567890123456789012345678901234567890123456789012
      SUBROUTINE FACTOR(KMAX,KM,K0,K1,K5,JMAX,JM)
C
C
C FACTOR THE TRIDIAGONAL MATRIX AM INTO TWO BIDIAGONAL
C MATRICES ALM AND AUM WITH ALM(N,2)=AUM(N,1), i.e.
C WITH Lii = Uii INSTEAD OF THE MORE FAMILIAR ( TO ME ] )
C VERSION WHERE THE MATRIX IS FACTORISED INTO L AND U
C WITH Lii = 1.
C
C	ASQ(K) = | Ak,k - Lk,k-1.Uk-1,k |**1/2
C
C	Lk,k-1 = Ak,k-1 / ASQ(K-1)
C
C	Uk,k   = ASQ(K)
C
C	Uk,k+1 = Ak,k+1 / ASQ(K)
C
      PARAMETER(NDXY=6000)
      DIMENSION ALM(NDXY,2),AM(NDXY,3),AUM(NDXY,2),BCM(NDXY,3)
      COMMON/BIG3S/ALM,AM,AUM,BCM
C
C FACTOR THE MATRIX AM INTO ALM AND AUM
C
      ALM(1,1)=AM(1,1)
      AUM(1,1)=AM(1,2)
C
      AUM(K0,2)=0.0
      L1=0
      A13=0.0
C
      DO 80 J=1,JMAX
         IF (J.EQ.1) THEN
	    L=K1
C!ONLY DO - HALF
         ELSE
	    L=L2
         ENDIF
C
         L1=L1+KMAX
         L2=L1+1
         L3=L1-2
         L4=L2-KM
         AM(L4,3)=AM(L4,3)-AM(L4,1)*A13/AM(L,2)
         AM(L,1)=0.0
C
C FACTOR AS IF BIDIAGONAL
C
         IF(J.EQ.JMAX) THEN
	    L5=L1-K5
C!ONLY DO + HALF
         ELSE
	    L5=L1-1
         ENDIF
C
         N1=L-1
         DO 60 N=L,L5
	    N2=N+1
	    ASQ=AM(N,2)-ALM(N,1)*AUM(N1,2)
	    IF(ASQ.LT.0.0) THEN
	       WRITE(6,*) 'ASQ < 0'
	       WRITE(6,*) 'N=', N
	       GO TO 90
	    ENDIF
	    IF(ASQ.EQ.0.0) THEN
	       WRITE(6,*) 'ASQ = 0'
	       WRITE(6,*) 'N=', N
	       GO TO 90
	    ENDIF
C
C ALM(N,2)=AUM(N,1) ARE THE DIAGONAL ELEMENTS
C
	    ASQ=SQRT(ASQ)
	    ALM(N,2)=ASQ
	    AUM(N,1)=ALM(N,2)
	    AUM(N,2)=AM(N,3)/ASQ
	    ALM(N2,1)=AM(N2,1)/ASQ
	    N1=N
 60      CONTINUE
C
C COMPUTE THE NONBIDIAGONAL ELEMENTS U(1,3) AND L(K,K-2)
C
         ALM(L,1)=A13/ALM(L,2)
         IF(J.LT.JMAX) THEN
	    AUM(L1,2)=AM(L1,3)/AUM(L3,1)
C
C CORRECT L(K,K-1)
C
	    ALM(L1,1)=ALM(L1,1)-AM(L1,3)*AUM(L3,2)/ASQ
C
C GET THE LAST DIAGONAL TERM
C
	    ALM(L1,2)=AM(L1,2)-ALM(L1,1)*AUM(L5,2)
	    AUM(L1,1)=ALM(L1,2)
	    A13=AM(L2,1)
         ENDIF
 80   CONTINUE
 90   RETURN
      END
C
C TRIM REMOVES NEGATIVE OUTPUT
C
      SUBROUTINE TRIM(KHS,KB1,KMAX,KM,K0,K1,JMAX,JM,NMAX)
C
      PARAMETER(NDXY=6000)
      DIMENSION FM(NDXY),HM(NDXY)
      COMMON/BIG1S/FM,HM
C
C SET THE NEGATIVE VALUES TO ZERO
C
      DO 20 L=1,NMAX
         IF(FM(L).LT.0.0) FM(L)=0.0
 20   CONTINUE
C
C SET THE ISOLATED VALUES TO ZERO
C DO THE + HALF
C
      DO 120 J=1,JM
         LP=J*KMAX
         DO 110 K=1,K0
	    L=LP+K
	    LY=L-KMAX
	    LYR=LY-1
	    LXR=L-1
	    LXL=L+1
	    IF(HM(L)) 30,30,110
 30	    IF(FM(LY)) 270,40,110
C CHECK FOR BOUNDRY
 40	    IF(K-1) 270,80,50
C CHECK FOR FOCUSING
 50	    IF(KHS) 60,80,60
 60	    IF(FM(LYR)) 270,70,110
 70	    IF(FM(LXR)) 270,80,110
C CHECK FOR DIFFUSION
 80	    IF(KB1) 90,100,90
 90	    IF(FM(LXL)) 270,100,110
 100	    FM(L)=0.0
 110     CONTINUE
 120  CONTINUE
C DO THE - HALF
 150  LP=NMAX-KMAX
      DO 250 J=1,JM
         LP=LP-KMAX
         DO 240 K=K1,KMAX
	    L=LP+K
	    LY=L+KMAX
	    LYR=LY-1
	    LXR=L-1
	    LXL=L+1
	    IF(HM(L)) 160,160,240
 160	    IF(FM(LY)) 270,170,240
C CHECK FOR FOCUSING
 170	    IF(KHS) 180,190,180
 180	    IF(FM(LYR)) 270,190,240
 190	    IF(FM(LXR)) 270,200,240
C CHECK FOR BOUNDRY
 200	    IF(KMAX-K) 270,230,210
C     CHECK FOR DIFFUSION
 210	    IF(KB1) 220,230,220
 220	    IF(FM(LXL)) 270,230,240
 230	    FM(L)=0.0
 240     CONTINUE
 250  CONTINUE
 260  RETURN
 270  WRITE(6,*) 'ERROR IN TRIM'
      GO TO 260
      END
C
C2345678901234567890123456789012345678901234567890123456789012345
C This will take FM and find any isolated zeroes or isolated    c
C pairs of zeroes and replace them with linear interpolations   c
C from the points on each sides, unless they are inside the     c
C interval given by Mucr				        c
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE TRIM1(DPA,X,MUCR,JMAX,KMAX,KM,B2,A02,JSTOP)
C
      PARAMETER(NDXY=6000,NDX=30,NDY=200)
      REAL MUCR
      DIMENSION FM(NDXY),HM(NDXY),DPA(NDX),X(NDX),MUCR(NDY)
      COMMON/BIG1S/FM,HM
C
      IF(B2.GT.1.0) THEN
C!B.C.'S DETERMINE WHAT HAPPENS AT K=1
         EXT=-0.05
      ELSE
         IF(A02.EQ.0.0) THEN
	    EXT=0.0
         ELSE
	    EXT=0.05
         ENDIF
      ENDIF
C
      IF(JSTOP.LT.JMAX) THEN
         JSP=JSTOP+1
      ELSE
         JSP=JMAX
      ENDIF
      DO 10 J=1,JSP
         NK=(J-1)*KMAX
         DO 20 K=1,KM
	    N=NK+K
	    IF(FM(N).GT.0.0) GO TO 20
C
C ELSE, FM(N)<0.0
C
	    IF(ABS(X(K)).LE.MUCR(J)) THEN
               FM(N)=0.0
               DO 16 L=K,KM
                  N=NK+L
                  IF(FM(N).LT.0.0) FM(N)=0.0
 16            CONTINUE
               GO TO 10
C!NEXT J
	    ENDIF
C
	    IF(FM(N+1).GT.0.0) THEN
               TEMP1=ALOG(FM(N+1))
               IF(K.EQ.1) THEN
		  FM(N)=EXP(TEMP1+EXT)
               ELSE
C!(K.GT.1)
		  TEMP2=ALOG(FM(N-1))
		  TEMP=DPA(K)*(TEMP1-TEMP2)/(DPA(K+1)+DPA(K))
C
C DPA(K)=PA(K)-PA(K-1)
C
		  FM(N)=EXP(TEMP2+TEMP)    
               ENDIF
	    ELSE
C!FM(N+1).LE.0.0
               IF(FM(N+2).LE.0.0) THEN
		  DO 18 KTY=K,KMAX
                     N=NK+KTY
                     FM(N)=0.0
 18		  CONTINUE
		  GO TO 10
C!NEXT J
               ENDIF
C
               IF(K.EQ.KM) THEN
		  FM(N)=0.0
		  FM(N+1)=0.0
		  GO TO 10
               ENDIF
C
               TEMP1=ALOG(FM(N+2))
               IF(K.EQ.1) THEN
		  FM(N)=EXP(TEMP1+2.0+EXT)
               ELSE
C!K.GT.1
		  TEMP2=ALOG(FM(N-1))
		  TEMP=DPA(K)*(TEMP1-TEMP2)/(DPA(K+2)+DPA(K+1)+DPA(K))
		  FM(N)=EXP(TEMP2+TEMP)
               ENDIF
	    ENDIF
 20      CONTINUE
C
C FOR K=KMAX, WE EXTRAPOLATE
C
         N=N+1
         IF(FM(N).LE.0.0) THEN
	    TEMP1=ALOG(FM(N-1))
	    TEMP=(TEMP1-ALOG(FM(N-2)))*DPA(KMAX)/DPA(KM)
	    FM(N)=EXP(TEMP1+TEMP)
         ENDIF
 10   CONTINUE
C
C NEXT,TRUNCATE
C
      IF(JSP.LT.JMAX) THEN
         JSPP=JSP+1
         DO 30 J=JSPP,JMAX
	    NK=(J-1)*KMAX
	    DO 29 K=1,KMAX
               N=NK+K
               FM(N)=0.0
               HM(N)=0.0
 29	    CONTINUE
 30      CONTINUE
      ENDIF
C
      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C TRIM2 will take FM(N) and send a stripped version FIN(J,K) back C
C to the main program,the idea here is to aviod bad solutions     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC	    
      SUBROUTINE TRIM2(FM,FIN,X,MUCR,JMAX,KMAX,JSTOP,KFAN)
C
      PARAMETER(NDXY=6000,NDX=30,NDY=200)
      REAL MUCR
      DIMENSION FM(NDXY),FIN(NDY,NDX),MUCR(NDY),X(NDX)
C 
      DO 4 J=1,JMAX
         DO 2 K=1,KMAX
	    FIN(J,K)=0.0
 2       CONTINUE
 4    CONTINUE
C
      DO 5 J=1,JSTOP
         NK=KMAX*(J-1)
         DO 6 K=1,KMAX
	    N=NK+K
	    FIN(J,K)=FM(N)
	    IF(FIN(J,K).LE.0.0) THEN
               FIN(J,K)=0.0
               IF(K.EQ.1) THEN
		  IF(KFAN.EQ.0) GO TO 10
               ELSE
		  IF(FIN(J,K-1).LE.0.0) THEN
                     IF(ABS(X(K-1)).GT.MUCR(J)) GO TO 5
C!NEXT J
		  ENDIF
               ENDIF
	    ENDIF
 6       CONTINUE
 5    CONTINUE
C
 10   DO 8 J=1,JMAX
         NK=KMAX*(J-1)
         DO 7 K=1,KMAX
	    N=NK+K
	    FM(N)=FIN(J,K)
 7       CONTINUE
 8    CONTINUE
      RETURN
      END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Hunt, given an array XX of length N, and given a value X, hunt returns
c a value JLO such that X is between XX(JLO) and XX(JLO+1). XX must be,
c monotonic, either increasing or decreasing. JLO=0 or JLO=N is returned
c to indicate that X is out of range. JLO on input is taken as the 
c initial guess for JLO on output. From Numerical Recipies Chapter 3.
c23456789012345678901234567890123456789012345678901234567890123456789012
      SUBROUTINE HUNT(XX, N, X, JLO)
      DIMENSION XX(N)
      LOGICAL ASCND
C ASCND=TRUE IF THE VALUES ARE INCREASING
      ASCND=XX(N).GT.XX(1)
      IF(JLO.LE.0.OR.JLO.GT.N)THEN
C INPUT GUESS IS NOT SO USEFUL, BISECT
         JLO=0
         JHI=N+1
         GO TO 3
      ENDIF
C SET THE HUNTING INCREMENT
      INC=1
      IF(X.GE.XX(JLO).EQV.ASCND)THEN
C HUNT UP
 1       JHI=JLO+INC
         IF(JHI.GT.N) THEN
C DONE HUNTING, SINCE YOU'RE OFF THE END OF THE TABLE
            JHI=N+1
         ELSE IF(X.GE.XX(JHI).EQV.ASCND)THEN
C NOT DONE HUNTING, DOUBLE THE INCREMENT AND TRY AGAIN
            JLO=JHI
            INC=INC+INC
            GO TO 1
         ENDIF
      ELSE
C HUNT DOWN
         JHI=JLO
 2       JLO=JHI-INC
         IF(JLO.LT.1)THEN
C DONE HUNTING, SINCE YOU'RE OFF THE END OF THE TABLE
            JLO=0
         ELSE IF(X.LT.XX(JLO).EQV.ASCND)THEN
C NOT DONE HUNTING, DOUBLE THE INCREMENT AND TRY AGAIN
            JHI=JLO
            INC=INC+INC
            GO TO 2
         ENDIF
      ENDIF
C DONE, SO BISECT
 3    IF(JHI-JLO.EQ.1)RETURN
      JM=(JHI+JLO)/2
      IF(X.GT.XX(JM).EQV.ASCND)THEN
         JLO=JM
      ELSE
         JHI=JM
      ENDIF
      GO TO 3
      END
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c NAME:
c	xinterp
c PURPOSE:
c	Linearly interpolate vectors 
c CALLING SEQUENCE:
c	call xinterp(x, y, nx, u, v, nu)
c       call xinterp(x(0), y(0), nx+1, etc..., if y and x are declared as
c            dimension y(0:nx), x(0:nx) in the calling routine
c INPUTS:
c	x: The absicissae values for y.  
c          The values MUST be monotonically ascending 
c	   or descending.
c	y: The input vector.
c       nx: the number of elements in x and y
c	u: The absicissae values for the result.  
c          u does not need to be monotonic, but it helps
c       nu: the number of elements in u	
c OUTPUTS:
c       v: a floating-point vector of nu points determined
c	by linearly interpolating the input vector.
c PROCEDURE:
c	v = y(x(j))+(u-x(j))*(y(j+1)-y(j))/(x(j+1)-x(j))
c              where j is the point on the x grid just below u
c HISTORY:
c       jmm 28-feb-97
c23456789012345678901234567890123456789012345678901234567890123456789012
      subroutine xinterp(x, y, nx, u, v, nu)
c
      real y(nx), x(nx), u(nu), v(nu)
c
      if(nx.lt.2) then
         write(6,*) 'Crashing, cannot interpolate without 2 elements'
         return
      endif
c
      j = 1
      do 20 i = 1, nu
c find the point on the x grid just below u(i)
         call hunt(x, nx, u(i), j)
c interpolate
         if(j.eq.0) then
            j0 = 1
            j1 = 2
         else if(j.eq.nx) then
            j0 = nx-1
            j1 = nx
         else
            j0 = j
            j1 = j+1
         endif
         aa = (u(i)-x(j0))/(x(j1)-x(j0))
         v(i) = y(j0)*(1.0-aa)+y(j1)*aa
 20   continue

      return
      end



